#pragma once
#include "Component.h"
#include "../core/audio/AudioEngine.h"
#include "../core/utils/AssetManager.h"
#include <string>

class AudioPlayerComponent : public Component
{
public:
    AudioPlayerComponent(Object* owner);
    ~AudioPlayerComponent();

    void SetAudio(uint64_t uaid);
    void Play();
    void Pause();
    void Stop();

    void SetLooping(bool loop);
    void SetVolume(float vol);

    bool IsPlaying() const;

    // Serialization
    std::string GetName() const override;
    void Save(YAML::Emitter& out) const override;
    void Load(const YAML::Node& node) override;

    uint64_t GetUAID() const { return m_UAID; }

private:
    ma_sound* m_Sound = nullptr;
    uint64_t m_UAID = 0;
    bool m_OwnsSound = false;

    float volume = 1.0f;
    bool loop = false;
};
